"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createObservableComponent = void 0;
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var destroyer_1 = require("../../helpers/destroyer");
var DynamicEntry_1 = require("./dynamic-entry/DynamicEntry");
var helpers_1 = require("./helpers");
function createObservableComponent() {
    var update$ = new rxjs_1.ReplaySubject(1);
    var _a = tslib_1.__read(destroyer_1.createDestroyer(), 2), destroy = _a[0], destroy$ = _a[1];
    var dynamicChild = DynamicEntry_1.DynamicEntry();
    destroy$.subscribe(dynamicChild.destroy);
    var result$ = new rxjs_1.Observable(function (observer) {
        dynamicChild.result$.subscribe(observer);
        return update$
            .pipe(operators_1.switchMap(function (o) { return o; }), operators_1.takeUntil(destroy$))
            .subscribe(dynamicChild.update$);
    });
    return {
        type: helpers_1.ComponentType.observable,
        // lifecycle
        update$: update$,
        destroy: destroy,
        // out
        result$: result$,
    };
}
exports.createObservableComponent = createObservableComponent;
