"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStaticComponent = void 0;
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var destroyer_1 = require("../../helpers/destroyer");
var DynamicEntry_1 = require("./dynamic-entry/DynamicEntry");
var helpers_1 = require("./helpers");
exports.createStaticComponent = function (element) {
    var update$ = new rxjs_1.ReplaySubject(1);
    var _a = tslib_1.__read(destroyer_1.createDestroyer(), 2), destroy = _a[0], destroy$ = _a[1];
    var element$ = new rxjs_1.ReplaySubject(1);
    var dynamicChildren = element.props.children.map(function () { return DynamicEntry_1.DynamicEntry(); });
    destroy$.subscribe(function () {
        dynamicChildren.forEach(function (child) { return child.destroy(); });
        element$.complete();
    });
    var change$ = new rxjs_1.Observable(function (observer) {
        dynamicChildren.forEach(function (child, i) {
            update$
                .pipe(operators_1.map(function (update) { return update.props.children[i]; }), operators_1.takeUntil(destroy$))
                .subscribe(child.update$);
        });
        // Ref handling
        // TODO: consider making ref a function instead of Subject
        rxjs_1.combineLatest(update$.pipe(operators_1.pluck('props', 'ref')), element$)
            .pipe(operators_1.takeUntil(destroy$))
            .subscribe(function (_a) {
            var _b = tslib_1.__read(_a, 2), ref = _b[0], element = _b[1];
            if (!ref || typeof ref.next != 'function') {
                return;
            }
            ref.next(element);
        });
        return update$
            .pipe(operators_1.pluck('props'), operators_1.takeUntil(destroy$))
            .subscribe(observer);
    });
    return {
        type: helpers_1.ComponentType.static,
        definition: element,
        // lifecycle
        update$: update$,
        element$: element$,
        destroy: destroy,
        // output
        change$: change$,
        dynamicChildren: dynamicChildren,
    };
};
