"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReplayDynamicEntry = void 0;
var rxjs_1 = require("rxjs");
var DynamicEntry_1 = require("./DynamicEntry");
// NOTE: ReplaySubject is need because array updates is using combineLatest.
// Since some elements would update while others would be stale, we need to
// store DynamicEntry latest component to be reused when resubscribed
exports.ReplayDynamicEntry = function () {
    var entry = DynamicEntry_1.DynamicEntry();
    var update$ = new rxjs_1.Subject();
    var result$ = new rxjs_1.ReplaySubject(1);
    var connected = false;
    var connect = function () {
        if (connected) {
            return;
        }
        connected = true;
        entry.result$.subscribe(result$);
        update$.subscribe(entry.update$);
    };
    var destroy = function () {
        update$.complete();
        entry.destroy();
    };
    return {
        update$: update$,
        result$: result$,
        connect: connect,
        destroy: destroy,
    };
};
