"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderArray = void 0;
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var _1 = require(".");
var destroyer_1 = require("../../helpers/destroyer");
function renderArray(component, xmlns) {
    // NOTE: this code block is similar to Array Component logic
    // TODO: refactor
    var HTMLElementStreams = new Map();
    return component.items$.pipe(operators_1.startWith(null), operators_1.pairwise(), operators_1.switchMap(function (_a) {
        var _b = tslib_1.__read(_a, 2), prev = _b[0], curr = _b[1];
        // shortcut
        // if curr array is empty
        if (curr.length == 0) {
            HTMLElementStreams.clear();
            return rxjs_1.of([]);
        }
        // removing obsolete keys
        if (prev && prev.length != 0) {
            for (var prevIndex = 0; prevIndex < prev.length; prevIndex++) {
                var shouldRemove = true;
                var prevItem = prev[prevIndex];
                var prevKey = prevItem.key;
                var prevComp = prevItem.component;
                for (var currIndex = 0; currIndex < curr.length; currIndex++) {
                    var currItem = curr[currIndex];
                    if (Object.is(prevKey, currItem.key) &&
                        prevComp === currItem.component) {
                        shouldRemove = false;
                        break;
                    }
                }
                if (shouldRemove) {
                    var domStream = HTMLElementStreams.get(prevKey);
                    domStream.destroy();
                    HTMLElementStreams.delete(prevKey);
                }
            }
        }
        var itemStreams = curr.map(function (entry) {
            var key = entry.key, component = entry.component;
            var elementStream = HTMLElementStreams.get(key);
            if (elementStream != null) {
                return elementStream.result$;
            }
            var _a = tslib_1.__read(destroyer_1.createDestroyer(), 2), destroy = _a[0], destroy$ = _a[1];
            var _result$ = new rxjs_1.ReplaySubject(1);
            var result$ = _result$.pipe(operators_1.takeUntil(destroy$));
            _1.renderComponent(component, xmlns)
                .pipe(operators_1.map(
            // NOTE: casting ICompiledComponent to IRenderElement here
            //       currently array child cannot be another array
            function (renderElement) { return ({
                key: key,
                renderElement: renderElement,
            }); }), operators_1.takeUntil(destroy$))
                .subscribe(_result$);
            HTMLElementStreams.set(key, { component: component, result$: result$, destroy: destroy });
            return result$;
        });
        return rxjs_1.combineLatest.apply(void 0, tslib_1.__spread(itemStreams));
    }));
}
exports.renderArray = renderArray;
