import { ReplaySubject } from 'rxjs';
import { takeUntil } from 'rxjs/operators';
import { createDestroyer } from '../../helpers/destroyer';
import { ComponentType } from './helpers';
export function createLeafComponent(child) {
    const update$ = new ReplaySubject(1);
    const [destroy, destroy$] = createDestroyer();
    const render$ = update$.pipe(takeUntil(destroy$));
    return {
        type: ComponentType.leaf,
        data: child,
        // lifecycle
        update$,
        destroy,
        // out
        render$,
    };
}
