import { Observable, ReplaySubject } from 'rxjs';
import { switchMap, takeUntil } from 'rxjs/operators';
import { createDestroyer } from '../../helpers/destroyer';
import { DynamicEntry } from './dynamic-entry/DynamicEntry';
import { ComponentType } from './helpers';
export function createObservableComponent() {
    const update$ = new ReplaySubject(1);
    const [destroy, destroy$] = createDestroyer();
    const dynamicChild = DynamicEntry();
    destroy$.subscribe(dynamicChild.destroy);
    const result$ = new Observable((observer) => {
        dynamicChild.result$.subscribe(observer);
        return update$
            .pipe(switchMap((o) => o), takeUntil(destroy$))
            .subscribe(dynamicChild.update$);
    });
    return {
        type: ComponentType.observable,
        // lifecycle
        update$,
        destroy,
        // out
        result$,
    };
}
