import { __read } from "tslib";
import { Observable, ReplaySubject } from 'rxjs';
import { switchMap, takeUntil } from 'rxjs/operators';
import { createDestroyer } from '../../helpers/destroyer';
import { DynamicEntry } from './dynamic-entry/DynamicEntry';
import { ComponentType } from './helpers';
export function createObservableComponent() {
    var update$ = new ReplaySubject(1);
    var _a = __read(createDestroyer(), 2), destroy = _a[0], destroy$ = _a[1];
    var dynamicChild = DynamicEntry();
    destroy$.subscribe(dynamicChild.destroy);
    var result$ = new Observable(function (observer) {
        dynamicChild.result$.subscribe(observer);
        return update$
            .pipe(switchMap(function (o) { return o; }), takeUntil(destroy$))
            .subscribe(dynamicChild.update$);
    });
    return {
        type: ComponentType.observable,
        // lifecycle
        update$: update$,
        destroy: destroy,
        // out
        result$: result$,
    };
}
