import { __read } from "tslib";
import { combineLatest, Observable, ReplaySubject } from 'rxjs';
import { map, pluck, takeUntil } from 'rxjs/operators';
import { createDestroyer } from '../../helpers/destroyer';
import { DynamicEntry } from './dynamic-entry/DynamicEntry';
import { ComponentType } from './helpers';
export var createStaticComponent = function (element) {
    var update$ = new ReplaySubject(1);
    var _a = __read(createDestroyer(), 2), destroy = _a[0], destroy$ = _a[1];
    var element$ = new ReplaySubject(1);
    var dynamicChildren = element.props.children.map(function () { return DynamicEntry(); });
    destroy$.subscribe(function () {
        dynamicChildren.forEach(function (child) { return child.destroy(); });
        element$.complete();
    });
    var change$ = new Observable(function (observer) {
        dynamicChildren.forEach(function (child, i) {
            update$
                .pipe(map(function (update) { return update.props.children[i]; }), takeUntil(destroy$))
                .subscribe(child.update$);
        });
        // Ref handling
        // TODO: consider making ref a function instead of Subject
        combineLatest(update$.pipe(pluck('props', 'ref')), element$)
            .pipe(takeUntil(destroy$))
            .subscribe(function (_a) {
            var _b = __read(_a, 2), ref = _b[0], element = _b[1];
            if (!ref || typeof ref.next != 'function') {
                return;
            }
            ref.next(element);
        });
        return update$
            .pipe(pluck('props'), takeUntil(destroy$))
            .subscribe(observer);
    });
    return {
        type: ComponentType.static,
        definition: element,
        // lifecycle
        update$: update$,
        element$: element$,
        destroy: destroy,
        // output
        change$: change$,
        dynamicChildren: dynamicChildren,
    };
};
