import { ReplaySubject, Subject } from 'rxjs';
import { DynamicEntry } from './DynamicEntry';
// NOTE: ReplaySubject is need because array updates is using combineLatest.
// Since some elements would update while others would be stale, we need to
// store DynamicEntry latest component to be reused when resubscribed
export var ReplayDynamicEntry = function () {
    var entry = DynamicEntry();
    var update$ = new Subject();
    var result$ = new ReplaySubject(1);
    var connected = false;
    var connect = function () {
        if (connected) {
            return;
        }
        connected = true;
        entry.result$.subscribe(result$);
        update$.subscribe(entry.update$);
    };
    var destroy = function () {
        update$.complete();
        entry.destroy();
    };
    return {
        update$: update$,
        result$: result$,
        connect: connect,
        destroy: destroy,
    };
};
