import { isObservable } from 'rxjs';
import { isArray } from '../../helpers/isArray';
import { isFunction } from '../../helpers/isFunction';
import { isThenable } from '../../helpers/isThenable';
import { isElement } from '../Element';
export var ComponentType;
(function (ComponentType) {
    ComponentType["leaf"] = "leaf";
    ComponentType["fn"] = "fn";
    ComponentType["array"] = "array";
    ComponentType["observable"] = "observable";
    ComponentType["static"] = "static";
})(ComponentType || (ComponentType = {}));
export function getType(child) {
    if (isObservable(child) || isThenable(child)) {
        return ComponentType.observable;
    }
    else if (isArray(child)) {
        return ComponentType.array;
    }
    else if (isElement(child)) {
        if (typeof child.type == 'string') {
            return ComponentType.static;
        }
        else if (isFunction(child.type)) {
            return ComponentType.fn;
        }
    }
    return ComponentType.leaf;
}
