import { __read, __spread } from "tslib";
import { combineLatest, of, ReplaySubject } from 'rxjs';
import { map, pairwise, startWith, switchMap, takeUntil } from 'rxjs/operators';
import { renderComponent } from '.';
import { createDestroyer } from '../../helpers/destroyer';
export function renderArray(component, xmlns) {
    // NOTE: this code block is similar to Array Component logic
    // TODO: refactor
    var HTMLElementStreams = new Map();
    return component.items$.pipe(startWith(null), pairwise(), switchMap(function (_a) {
        var _b = __read(_a, 2), prev = _b[0], curr = _b[1];
        // shortcut
        // if curr array is empty
        if (curr.length == 0) {
            HTMLElementStreams.clear();
            return of([]);
        }
        // removing obsolete keys
        if (prev && prev.length != 0) {
            for (var prevIndex = 0; prevIndex < prev.length; prevIndex++) {
                var shouldRemove = true;
                var prevItem = prev[prevIndex];
                var prevKey = prevItem.key;
                var prevComp = prevItem.component;
                for (var currIndex = 0; currIndex < curr.length; currIndex++) {
                    var currItem = curr[currIndex];
                    if (Object.is(prevKey, currItem.key) &&
                        prevComp === currItem.component) {
                        shouldRemove = false;
                        break;
                    }
                }
                if (shouldRemove) {
                    var domStream = HTMLElementStreams.get(prevKey);
                    domStream.destroy();
                    HTMLElementStreams.delete(prevKey);
                }
            }
        }
        var itemStreams = curr.map(function (entry) {
            var key = entry.key, component = entry.component;
            var elementStream = HTMLElementStreams.get(key);
            if (elementStream != null) {
                return elementStream.result$;
            }
            var _a = __read(createDestroyer(), 2), destroy = _a[0], destroy$ = _a[1];
            var _result$ = new ReplaySubject(1);
            var result$ = _result$.pipe(takeUntil(destroy$));
            renderComponent(component, xmlns)
                .pipe(map(
            // NOTE: casting ICompiledComponent to IRenderElement here
            //       currently array child cannot be another array
            function (renderElement) { return ({
                key: key,
                renderElement: renderElement,
            }); }), takeUntil(destroy$))
                .subscribe(_result$);
            HTMLElementStreams.set(key, { component: component, result$: result$, destroy: destroy });
            return result$;
        });
        return combineLatest.apply(void 0, __spread(itemStreams));
    }));
}
