import { Observer } from 'rxjs';
import { IChild } from '../IChild';
import { IArrayComponent } from './Array';
import { IFnComponent } from './Fn';
import { ILeafComponent } from './Leaf';
import { IObservableComponent } from './Observable';
import { IStaticComponent } from './Static';
export interface IBasicComponent {
    update$: Observer<IChild>;
    destroy: () => void;
}
export declare type IComponent = ILeafComponent | IStaticComponent | IObservableComponent | IFnComponent | IArrayComponent;
export declare enum ComponentType {
    leaf = "leaf",
    fn = "fn",
    array = "array",
    observable = "observable",
    static = "static"
}
export declare function getType(child: IChild): ComponentType;
//# sourceMappingURL=helpers.d.ts.map